// Zorg ervoor dat links niet extern worden geopend in WebApp
(function(a,b,c){if(c in b&&b[c]){var d,e=a.location,f=/^(a|html)$/i;a.addEventListener("click",function(a){d=a.target;while(!f.test(d.nodeName))d=d.parentNode;"href"in d&&(d.href.indexOf("http")||~d.href.indexOf(e.host))&&(a.preventDefault(),e.href=d.href)},!1)}})(document,window.navigator,"standalone")

function lightbox_open(){
    window.scrollTo(0,0);
	$('#light').fadeIn('fast');
    $('#fade').fadeIn('fast');
	return setTimeout(function() {
            // run close function on completion of timeout0-9p
            lightbox_close();
        }, 2000);
}

function lightbox_close(){
	$('#light').fadeOut('fast');
	$('#fade').fadeOut('fast');
}

function RefreshData()
{
	clearInterval($.refreshTimer);
	var jurl=$.domoticzurl+"/json.htm?type=devices&plan="+$.roomplan+"&jsoncallback=?";
	$.getJSON(jurl,
	{
		format: "json"
	},
	function(data) {
		if (typeof data.result != 'undefined') {
			
			$.each(data.result, function(i,item){
				for( var ii = 0, len = $.PageArray.length; ii < len; ii++ ) {
					if( $.PageArray[ii][0] === item.idx ) {		// Domoticz idx number
						var vtype=	$.PageArray[ii][1]; 		// Domoticz type (like Temp, Humidity)
						var vlabel=	$.PageArray[ii][2];			// cell number from HTML layout
						var vdesc=	$.PageArray[ii][3];			// description 
						var vattr=	$.PageArray[ii][4];			// extra css attributes
						var valarm=	$.PageArray[ii][5]; 		// alarm value to turn text to red
						var vdata=	item[vtype];				// current value
						if (typeof vdata == 'undefined') {
							vdata="??";
						} else {
							// remove too much text
							vdata=new String(vdata).split("Lux",1)[0];
							vdata=new String(vdata).split("Watt",1)[0];
							vdata=new String(vdata).split("kWh",1)[0];
							vdata=new String(vdata).split("m3",1)[0];
							vdata=new String(vdata).split(" Level:",1)[0];
							vdata=new String(vdata).replace("Set","On");
							vdata=new String(vdata).replace("true","protected");
							
							//If IDX matches '1' (RAM usage) or '5' (CPU usage), then strip off the '%' and round the numbers
							if(item.idx == '1' || item.idx == '5'){
							vdata=new String(vdata).split("%",1)[0];
							vdata=Math.round(vdata);
							}	
						
						}
						
						//If IDX matches '48' (Electricity today) or '50' (Gas today), then round the numbers with 1 decimal
						if(item.idx == '48' || item.idx == '50'){
							vdata=new String(vdata).split("kWh",1)[0];
							vdata=new String(vdata).split("m3",1)[0];
							vdata=Math.round(vdata * 10) / 10;
							
						}
					
						//If IDX matches '380' (Water) covert m3 to liters
						if(item.idx == '380'){
							vdata=new String(vdata).split("m3",1)[0];
							vdata=Math.round(vdata * 1000);
						}
						
						// create switchable value when item is switch
						switchclick='';
						if (vdata == 'Off' ) {
							switchclick = 'onclick="SwitchToggle('+item.idx+', \'On\');"';
						}
						if (vdata == 'On' ) {
							switchclick = 'onclick="SwitchToggle('+item.idx+', \'Off\');"';
						}
												
						// if alarm threshold is defined, make value red 
						//alarmcss='';
						//if (typeof valarm != 'undefined') {
						//	if ( eval(vdata + valarm)) {  // note orig:  vdata > alarm
						//		alarmcss=';color:red;';
						//	}
						//}

						// if switch is on, make green, if off, make red. Apply background when switch is not protected.
						alarmcss='';
								if (item.Protected == true) {
									if (vdata == 'On') {
										alarmcss=';color:#1B9772;';
										vdata = 'Aan';
									}
									if (vdata == 'Off') {
										alarmcss=';color:#E24E2A;';
										vdata = 'Uit';
									}
								} else {
								if (vdata == 'On') {
									alarmcss=';color:#1B9772;background-color:#000000;';
									vdata = 'Aan';
									}
								if (vdata == 'Off') {
									alarmcss=';color:#E24E2A;;background-color:#000000;';
									vdata = 'Uit';
									}
							}
							
						// if extra css attributes. Make switch not switchable when it is protected.
						if (typeof vattr == 'undefined') {
							if (item.Protected == true) {
									$('#'+vlabel).html('<div onClick="lightbox_open();" style='+alarmcss+'>'+vdata+'</div>');
							} else { 
									$('#'+vlabel).html('<div '+switchclick+' style='+alarmcss+'>'+vdata+'</div>');
							}
						} 
						if (item.Protected == true) {
							$('#'+vlabel).html( '<div onClick="lightbox_open();" style='+vattr+alarmcss+'>'+vdata+'</div>');
						} else {
							$('#'+vlabel).html( '<div '+switchclick+' style='+vattr+alarmcss+'>'+vdata+'</div>');
						}
						
						$('#desc_'+vlabel).html(vdesc);
					}
				}
			});
		}
	});
	$.refreshTimer = setInterval(RefreshData, 4000);
}

// ############################################################################################################
// #### vvvvv   USER VALUES below vvvvv   #######
// ############################################################################################################

$(document).ready(function() {
	$.roomplan=0;   	// define roomplan in Domoticz and create items below.
	$.domoticzurl="http://192.168.2.9:8090";
	//format: idx, value, label, description, [override css], [alarm value]
	$.PageArray = [
		//Page 1
		['11',	'Data',				'cell1',	'CPU verbruik RPI',],
		['27',  'Temp',				'cell2',	'Temperatuur trappengat (&deg;C)'],
		['26',	'Data',				'cell3',	'Trap lichtintensiteit (Lux)',],

		['', 	'CounterToday',		'cell4',	'Water Vandaag (l)',],
		['29',	'Data',				'cell5',	'Tot. verbr. LED trap (kWh)',],
		['',	'Status',			'cell6',	'Alarm Systeem',],
		['',	'Status',			'cell7',	'Iemand Aanwezig ?'],		
		
		['', 	'Temp',				'cell9',	'Garage (&deg;C)'],
		['1',	'Data',				'cell10',	'Verlichting lage stand',],
		['2',	'Data',				'cell11',	'Verlichting middelstand',],
		['3',	'Data',				'cell12',	'Verlichting hoge stand',],
		['',	'Temp',				'cell13',	'Badkamer (&deg;C)'],
	
		['38', 	'Status',			'cell14',	'Verlichting bank'],
		['49',	'Status',			'cell15',	'Verlichting draaitafel',],
		['39',	'Status',			'cell16',	'Licht eettafel muur',],
		['40',	'Status',			'cell17',	'Licht eettafel keuken',],
		['37',	'Status',			'cell18',	'Verlichting achterraam'],
		//Page 2
		['41',	'Status',			'cell2-1',	'DonkerBuiten knop (vir)'],
		['IDX',	'Status',			'cell2-2',	'Verlichting achterraam'],
		['45',	'Status',			'cell2-3',	'Bewegingssensor trap'],
		['IDX',	'Status',			'cell2-4',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-5',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-6',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-7',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-8',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-9',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-10',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-11',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-12',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-13',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-14',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-15',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-16',	'Verlichting achterraam'],
		['IDX',	'Status',			'cell2-17',	'Verlichting achterraam'],
	];

// ###########################################################################################################
// #### ^^^^^   USER VALUES above ^^^^^   #######
// ############################################################################################################


    RefreshData();
});  


 function SwitchToggle(idx, switchcmd)
    {
             console.log('function called');
             $.ajax({
         url: "json.htm?type=command&param=switchlight" + "&idx=" + idx + "&switchcmd=" + switchcmd + "&level=0",
        async: false,
        dataType: 'json',
        success: function(){
            console.log('SUCCES');
         },
         error: function(){
            console.log('ERROR');
         }
            });
            RefreshData();
    }
